diff -uNr mythtv-0.21/libs/libmythfreemheg/Root.h mythtv/libs/libmythfreemheg/Root.h
--- mythtv-0.21/libs/libmythfreemheg/Root.h	2006-04-06 22:23:34.000000000 +0200
+++ mythtv/libs/libmythfreemheg/Root.h	2008-12-11 23:59:27.000000000 +0100
@@ -176,6 +176,22 @@
     virtual void SetVideoDecodeOffset(int /*newXOffset*/, int /*newYOffset*/, MHEngine *) { InvalidAction("SetVideoDecodeOffset"); }
     virtual void GetVideoDecodeOffset(MHRoot * /*pXOffset*/, MHRoot */*pYOffset*/, MHEngine *) { InvalidAction("GetVideoDecodeOffset"); }
 
+    // Actions on Interactibles.
+    virtual void SetInteractionStatus(bool /*newStatus*/, MHEngine *) { InvalidAction("SetInteractionStatus"); }
+    virtual bool GetInteractionStatus(void) { InvalidAction("GetInteractionStatus"); return false; }
+    virtual void SetHighlightStatus(bool /*newStatus*/, MHEngine *engine) { InvalidAction("SetHighlightStatus"); }
+    virtual bool GetHighlightStatus(void) { InvalidAction("GetHighlightStatus"); return false; }
+
+    // Actions on Sliders.
+    virtual void Step(int /*nbSteps*/, MHEngine */*engine*/) { InvalidAction("Step"); }
+    virtual void SetSliderValue(int /*nbSteps*/, MHEngine */*engine*/) { InvalidAction("SetSliderValue"); }
+    virtual int GetSliderValue(void) { InvalidAction("GetSliderValue"); return 0; }
+    virtual void SetPortion(int /*newPortion*/, MHEngine */*engine*/) { InvalidAction("SetPortion"); }
+    virtual int GetPortion(void) { InvalidAction("GetPortion"); return 0; }
+    // Additional action defined in UK MHEG.
+    virtual void SetSliderParameters(int /*newMin*/, int /*newMax*/, int /*newStep*/, MHEngine */*engine*/)
+         { InvalidAction("SetSliderParameters"); }
+
 protected:
 
     void InvalidAction(const char *actionName);
diff -uNr mythtv-0.21/libs/libmythfreemheg/Text.cpp mythtv/libs/libmythfreemheg/Text.cpp
--- mythtv-0.21/libs/libmythfreemheg/Text.cpp	2007-01-05 16:26:11.000000000 +0100
+++ mythtv/libs/libmythfreemheg/Text.cpp	2008-12-11 23:59:27.000000000 +0100
@@ -1,6 +1,6 @@
 /* Text.cpp
 
-   Copyright (C)  David C. J. Matthews 2004  dm at prolingua.co.uk
+   Copyright (C)  David C. J. Matthews 2004, 2008  dm at prolingua.co.uk
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
@@ -463,6 +463,11 @@
                     pNewLine->m_Items.Append(pNewItem);
                     pNewItem->m_Unicode = pItem->m_Unicode.mid(nNewStart, nNewWidth);
                     pNewItem->m_nUnicode = nNewWidth;
+                    // Move any remaining items, e.g. in a different colour, from this line onto the new line.
+                    while (pLine->m_Items.Size() > j+1) {
+                        pNewLine->m_Items.Append(pLine->m_Items.GetAt(j+1));
+                        pLine->m_Items.RemoveAt(j+1);
+                    }
                 }
                 // Remove any spaces at the end of the old section.  If we don't do that and
                 // we are centering or right aligning the text we'll get it wrong.
@@ -534,7 +539,7 @@
 }
 
 
-MHHyperText::MHHyperText()
+MHHyperText::MHHyperText(): MHInteractible(this)
 {
 
 }
diff -uNr mythtv-0.21/libs/libmythfreemheg/Text.h mythtv/libs/libmythfreemheg/Text.h
--- mythtv-0.21/libs/libmythfreemheg/Text.h	2006-04-06 22:23:34.000000000 +0200
+++ mythtv/libs/libmythfreemheg/Text.h	2008-12-11 23:59:27.000000000 +0100
@@ -90,7 +90,7 @@
     void CreateContent(const unsigned char *p, int s, MHEngine *engine);
 };
 
-class MHHyperText : public MHText, public  MHInteractible
+class MHHyperText : public MHText, public MHInteractible
 {
 public:
     MHHyperText();
@@ -98,6 +98,15 @@
     virtual ~MHHyperText();
     virtual void Initialise(MHParseNode *p, MHEngine *engine);
     virtual void PrintMe(FILE *fd, int nTabs) const;
+
+    // Implement the actions in the main inheritance line.
+    virtual void SetInteractionStatus(bool newStatus, MHEngine *engine)
+    { InteractSetInteractionStatus(newStatus, engine); }
+    virtual bool GetInteractionStatus(void) { return InteractGetInteractionStatus(); }
+    virtual void SetHighlightStatus(bool newStatus, MHEngine *engine)
+    { InteractSetHighlightStatus(newStatus, engine); }
+    virtual bool GetHighlightStatus(void) { return InteractGetHighlightStatus(); }
+    virtual void Deactivation(MHEngine *engine) { InteractDeactivation(); }
 };
 
 // Get Text Data - get the data out of a text object.
diff -uNr mythtv-0.21/libs/libmythfreemheg/TokenGroup.cpp mythtv/libs/libmythfreemheg/TokenGroup.cpp
--- mythtv-0.21/libs/libmythfreemheg/TokenGroup.cpp	2006-04-06 22:23:34.000000000 +0200
+++ mythtv/libs/libmythfreemheg/TokenGroup.cpp	2008-12-11 23:59:27.000000000 +0100
@@ -54,7 +54,8 @@
         for (int i = 0; i < m_ActionSlots.Size(); i++) {
             PrintTabs(fd, nTabs+2); fprintf(fd, "(\n");
             MHActionSequence *pActions = m_ActionSlots.GetAt(i);
-            if (pActions->Size() == 0) fprintf(fd, "NULL\n");
+            if (pActions->Size() == 0) 
+                { PrintTabs(fd, nTabs+2); fprintf(fd, "NULL\n"); }
             else pActions->PrintMe(fd, nTabs+2);
             PrintTabs(fd, nTabs+2); fprintf(fd, ")\n");
         }
diff -uNr mythtv-0.21/libs/libmythfreemheg/Visible.cpp mythtv/libs/libmythfreemheg/Visible.cpp
--- mythtv-0.21/libs/libmythfreemheg/Visible.cpp	2007-01-05 16:26:11.000000000 +0100
+++ mythtv/libs/libmythfreemheg/Visible.cpp	2008-12-11 23:59:27.000000000 +0100
@@ -345,9 +345,11 @@
 }
 
 
-MHInteractible::MHInteractible()
+MHInteractible::MHInteractible(MHVisible *parent): m_parent(parent)
 {
-
+    m_fEngineResp = true;
+    m_fHighlightStatus = false;
+    m_fInteractionStatus = false;
 }
 
 MHInteractible::~MHInteractible()
@@ -355,41 +357,389 @@
 
 }
 
-void MHInteractible::Initialise(MHParseNode */*p*/, MHEngine */*engine*/)
+void MHInteractible::Initialise(MHParseNode *p, MHEngine *engine)
 {
+    // Engine Resp - optional
+    MHParseNode *pEngineResp = p->GetNamedArg(C_ENGINE_RESP);
+    if (pEngineResp) m_fEngineResp = pEngineResp->GetArgN(0)->GetBoolValue();
+    // Highlight colour.
+    MHParseNode *phlCol = p->GetNamedArg(C_HIGHLIGHT_REF_COLOUR);
+    if (phlCol) m_highlightRefColour.Initialise(phlCol->GetArgN(0), engine);
+    else engine->GetDefaultHighlightRefColour(m_highlightRefColour);
+    m_fHighlightStatus = false;
+    m_fInteractionStatus = false;
 }
 
-void MHInteractible::PrintMe(FILE */*fd*/, int /*nTabs*/) const
+void MHInteractible::PrintMe(FILE *fd, int nTabs) const
 {
+    if (! m_fEngineResp)  { PrintTabs(fd, nTabs); fprintf(fd, ":EngineResp false\n"); }
+
+    if (m_highlightRefColour.IsSet()) {
+        PrintTabs(fd, nTabs);
+        fprintf(fd, ":HighlightRefColour ");
+        m_highlightRefColour.PrintMe(fd, nTabs+1);
+        fprintf(fd, "\n");
+    }
 }
 
-MHSlider::MHSlider()
+void MHInteractible::Interaction(MHEngine *engine)
 {
+    m_fInteractionStatus = true;
+    engine->SetInteraction(this);
+    // The MHEG standard says: "generate visual feedback" here
+    // but it appears that any visual feedback is controlled only
+    // by the highlight status combined with engine-resp.
+}
 
+void MHInteractible::InteractSetInteractionStatus(bool newStatus, MHEngine *engine)
+{
+    if (newStatus) { // Turning interaction on.
+        if (engine->GetInteraction() == 0) // No current interactible
+            Interaction(engine); // virtual function
+    }
+    else { // Turning interaction off.
+        if (m_fInteractionStatus) {
+            m_fInteractionStatus = false;
+            engine->SetInteraction(0);
+            InteractionCompleted(engine); // Interaction is interrupted.
+            engine->EventTriggered(m_parent, EventInteractionCompleted);
+        }
+    }
 }
 
-MHSlider::~MHSlider()
+void MHInteractible::InteractSetHighlightStatus(bool newStatus, MHEngine *engine)
 {
+    if (newStatus == m_fHighlightStatus) return;
+    m_fHighlightStatus = newStatus;
+    // If active redraw to show change of status.
+    if (m_parent->GetRunningStatus() && m_fEngineResp)
+        engine->Redraw(m_parent->GetVisibleArea());
+    // Generate the event for the change of highlight status.
+    engine->EventTriggered(m_parent, m_fHighlightStatus ? EventHighlightOn: EventHighlightOff);
+}
 
+MHSlider::MHSlider(): MHInteractible(this)
+{
+    m_orientation = SliderLeft;
+    orig_max_value = -1;
+    orig_min_value = initial_value = orig_step_size = 1;
+    initial_portion = 0;
+    m_style = SliderNormal;
+}
+
+MHSlider::~MHSlider()
+{
 }
 
 void MHSlider::Initialise(MHParseNode *p, MHEngine *engine)
 {
     MHVisible::Initialise(p, engine);
     MHInteractible::Initialise(p, engine);
-    //
+    // 
+    MHParseNode *pOrientation = p->GetNamedArg(C_ORIENTATION);
+    if (pOrientation)
+        m_orientation = (enum SliderOrientation)pOrientation->GetArgN(0)->GetEnumValue();
+    // This is not optional.
+
+    MHParseNode *pMin = p->GetNamedArg(C_MIN_VALUE);
+    if (pMin) orig_min_value = pMin->GetArgN(0)->GetIntValue();
+    else orig_min_value = 1;
+
+    MHParseNode *pMax = p->GetNamedArg(C_MAX_VALUE);
+    if (pMax) orig_max_value = pMax->GetArgN(0)->GetIntValue();
+    else orig_max_value = orig_min_value-1; // Unset
+
+    MHParseNode *pInit = p->GetNamedArg(C_INITIAL_VALUE);
+    if (pInit) initial_value = pInit->GetArgN(0)->GetIntValue();
+    else initial_value = orig_min_value; // Default is min_value
+
+    MHParseNode *pPortion = p->GetNamedArg(C_INITIAL_PORTION);
+    if (pPortion) initial_portion = pPortion->GetArgN(0)->GetIntValue();
+    else initial_portion = orig_min_value-1; // Unset
+
+    MHParseNode *pStep = p->GetNamedArg(C_STEP_SIZE);
+    if (pStep) orig_step_size = pStep->GetArgN(0)->GetIntValue();
+    else orig_step_size = 1; // Unset
+
+    MHParseNode *pStyle = p->GetNamedArg(C_SLIDER_STYLE);
+    if (pStyle) m_style = (enum SliderStyle)pStyle->GetArgN(0)->GetEnumValue();
+    else m_style = SliderNormal;
+
+    MHParseNode *pslCol = p->GetNamedArg(C_SLIDER_REF_COLOUR);
+    if (pslCol) m_sliderRefColour.Initialise(pslCol->GetArgN(0), engine);
+    else engine->GetDefaultSliderRefColour(m_sliderRefColour);
+}
+
+static const char *rchOrientation[] =
+{
+    "left", // 1
+    "right",
+    "up",
+    "down" // 4
+};
+
+// Look up the Orientation. Returns zero if it doesn't match.  Used in the text parser only.
+int MHSlider::GetOrientation(const char *str)
+{
+    for (int i = 0; i < (int)(sizeof(rchOrientation)/sizeof(rchOrientation[0])); i++) {
+        if (strcasecmp(str, rchOrientation[i]) == 0) return (i+1); // Numbered from 1
+    }
+    return 0;
+}
+
+static const char *rchStyle[] =
+{
+    "normal", // 1
+    "thermometer",
+    "proportional" // 3
+};
+
+int MHSlider::GetStyle(const char *str)
+{
+    for (int i = 0; i < (int)(sizeof(rchStyle)/sizeof(rchStyle[0])); i++) {
+        if (strcasecmp(str, rchStyle[i]) == 0) return (i+1); // Numbered from 1
+    }
+    return 0;
 }
 
 void MHSlider::PrintMe(FILE *fd, int nTabs) const
 {
     PrintTabs(fd, nTabs); fprintf(fd, "{:Slider ");
-    MHVisible::PrintMe(fd, nTabs);
+    MHVisible::PrintMe(fd, nTabs+1);
     MHInteractible::PrintMe(fd, nTabs+1);
-    fprintf(fd, "****TODO\n");
+
+    PrintTabs(fd, nTabs); fprintf(fd, ":Orientation %s\n", rchOrientation[m_orientation-1]);
+
+    if (initial_value >= orig_min_value) {
+        PrintTabs(fd, nTabs+1); fprintf(fd, ":InitialValue %d\n", initial_value);
+    }
+
+    if (orig_min_value != 1) {
+        PrintTabs(fd, nTabs+1); fprintf(fd, ":MinValue %d\n", orig_min_value);
+    }
+
+    if (orig_max_value > orig_min_value) {
+        PrintTabs(fd, nTabs+1); fprintf(fd, ":MaxValue %d\n", orig_max_value);
+    }
+
+    if (initial_portion >= orig_min_value) {
+        PrintTabs(fd, nTabs+1); fprintf(fd, ":InitialPortion %d\n", initial_portion);
+    }
+
+    if (orig_step_size != 1) {
+        PrintTabs(fd, nTabs+1); fprintf(fd, ":StepSize %d\n", orig_step_size);
+    }
+
+    if (m_style != SliderNormal)
+    {
+        PrintTabs(fd, nTabs+1);
+        fprintf(fd, ":SliderStyle %s\n", rchStyle[m_style-1]);
+    }
+
+    if (m_sliderRefColour.IsSet()) {
+        PrintTabs(fd, nTabs+1);
+        fprintf(fd, ":SliderRefColour ");
+        m_sliderRefColour.PrintMe(fd, nTabs+2);
+        fprintf(fd, "\n");
+    }
+
     PrintTabs(fd, nTabs); fprintf(fd, "}\n");
 }
 
-MHEntryField::MHEntryField()
+// The MHEG standard doesn't define where the internal values are
+// initialised.  Assume it's during preparation.
+void MHSlider::Preparation(MHEngine *engine)
+{
+    MHVisible::Preparation(engine);
+    max_value = orig_max_value;
+    min_value = orig_min_value;
+    step_size = orig_step_size;
+    slider_value = initial_value;
+    portion = initial_portion;
+}
+
+void MHSlider::Display(MHEngine *engine)
+{
+    MHContext *d = engine->GetContext();
+    MHRgba colour;
+    if (m_fHighlightStatus && m_fEngineResp)
+        colour = GetColour(m_highlightRefColour);
+    else colour = GetColour(m_sliderRefColour);
+
+    int major; // Direction of change.
+    if (m_orientation == SliderLeft || m_orientation == SliderRight)
+        major = m_nBoxWidth;
+    else major = m_nBoxHeight;
+
+    if (max_value <= min_value) return; // Avoid divide by zero if error.
+
+    if (m_style == SliderNormal)
+    {
+        // This is drawn as a 9 pixel wide "thumb" at the position.
+        major -= 9; // Width of "thumb"
+        int posn = major * (slider_value-min_value) / (max_value-min_value);
+        switch (m_orientation)
+        {
+        case SliderLeft:
+            d->DrawRect(m_nPosX + posn, m_nPosY, 9, m_nBoxHeight, colour);
+            break;
+        case SliderRight:
+            d->DrawRect(m_nPosX + m_nBoxWidth - posn - 9, m_nPosY, 9, m_nBoxHeight, colour);
+            break;
+        case SliderUp:
+            d->DrawRect(m_nPosX, m_nPosY + m_nBoxHeight - posn - 9, m_nBoxWidth, 9, colour);
+            break;
+        case SliderDown:
+            d->DrawRect(m_nPosX, m_nPosY + posn, m_nBoxWidth, 9, colour);
+            break;
+        }
+    }
+    else {
+        // Thermometer and proportional sliders are drawn as bars.  Thermometers
+        // run from the start to the position, proportional sliders from the
+        // position for the "portion".
+        int start = 0;
+        int end = major * (slider_value-min_value) / (max_value-min_value);
+        if (m_style == SliderProp)
+        {
+            start = end;
+            end = major * (slider_value+portion -min_value) / (max_value-min_value);
+        }
+        switch (m_orientation)
+        {
+        case SliderLeft:
+            d->DrawRect(m_nPosX + start, m_nPosY, end-start, m_nBoxHeight, colour);
+            break;
+        case SliderRight:
+            d->DrawRect(m_nPosX + m_nBoxWidth - end, m_nPosY, end-start, m_nBoxHeight, colour);
+            break;
+        case SliderUp:
+            d->DrawRect(m_nPosX, m_nPosY + m_nBoxHeight - end, m_nBoxWidth, end-start, colour);
+            break;
+        case SliderDown:
+            d->DrawRect(m_nPosX, m_nPosY + start, m_nBoxWidth, end-start, colour);
+            break;
+        }
+
+    }
+}
+
+void MHSlider::Interaction(MHEngine *engine)
+{
+    MHInteractible::Interaction(engine);
+    // All the interaction is handled by KeyEvent.
+}
+
+// Called when the interaction has been terminated and we need
+// to restore the state to non-interacting.
+void MHSlider::InteractionCompleted(MHEngine *engine)
+{
+    MHInteractible::InteractionCompleted(engine);
+    // Redraw with the interaction highlighting turned off
+    engine->Redraw(GetVisibleArea());
+}
+
+// Called when a key is pressed.  The only keys that have an effect are
+// the Select and Cancel keys which both terminate the action and the
+// arrow keys.  The effect of the arrow keys depends on the orientation of
+// the slider.
+void MHSlider::KeyEvent(MHEngine *engine, int nCode)
+{
+    switch (nCode)
+    {
+    case 15: // Select key
+    case 16: // Cancel key
+        m_fInteractionStatus = false;
+        engine->SetInteraction(0);
+        InteractionCompleted(engine); // Interaction is interrupted.
+        engine->EventTriggered(this, EventInteractionCompleted);
+        break;
+
+    case 1: // Up
+        if (m_orientation == SliderUp)
+            Increment(engine);
+        else if (m_orientation == SliderDown)
+            Decrement(engine);
+        break;
+
+    case 2: // Down
+        if (m_orientation == SliderUp)
+            Decrement(engine);
+        else if (m_orientation == SliderDown)
+            Increment(engine);
+        break;
+
+    case 3: // Left
+        if (m_orientation == SliderLeft)
+            Increment(engine);
+        else if (m_orientation == SliderRight)
+            Decrement(engine);
+        break;
+
+    case 4: // Right
+        if (m_orientation == SliderLeft)
+            Decrement(engine);
+        else if (m_orientation == SliderRight)
+            Increment(engine);
+        break;
+
+    }
+}
+
+void MHSlider::Increment(MHEngine *engine)
+{
+    if (slider_value+step_size <= max_value)
+    {
+        slider_value += step_size;
+        engine->Redraw(GetVisibleArea());
+        engine->EventTriggered(this, EventSliderValueChanged);
+    }
+}
+
+void MHSlider::Decrement(MHEngine *engine)
+{
+    if (slider_value-step_size >= min_value)
+    {
+        slider_value -= step_size;
+        engine->Redraw(GetVisibleArea());
+        engine->EventTriggered(this, EventSliderValueChanged);
+    }
+}
+
+void MHSlider::Step(int nbSteps, MHEngine *engine)
+{
+    step_size = nbSteps;
+    if (m_fRunning) engine->Redraw(GetVisibleArea());
+    engine->EventTriggered(this, EventSliderValueChanged);
+}
+
+void MHSlider::SetSliderValue(int newValue, MHEngine *engine)
+{
+    slider_value = newValue;
+    if (m_fRunning) engine->Redraw(GetVisibleArea());
+    engine->EventTriggered(this, EventSliderValueChanged);
+}
+
+void MHSlider::SetPortion(int newPortion, MHEngine *engine)
+{
+    portion = newPortion;
+    if (m_fRunning) engine->Redraw(GetVisibleArea());
+    engine->EventTriggered(this, EventSliderValueChanged);
+}
+
+// Additional action defined in UK MHEG.
+void MHSlider::SetSliderParameters(int newMin, int newMax, int newStep, MHEngine *engine)
+{
+    min_value = newMin;
+    max_value = newMax;
+    step_size = newStep;
+    slider_value = newMin;
+    if (m_fRunning) engine->Redraw(GetVisibleArea());
+    engine->EventTriggered(this, EventSliderValueChanged);
+}
+
+
+MHEntryField::MHEntryField(): MHInteractible(this)
 {
 
 }
diff -uNr mythtv-0.21/libs/libmythfreemheg/Visible.h mythtv/libs/libmythfreemheg/Visible.h
--- mythtv-0.21/libs/libmythfreemheg/Visible.h	2006-04-06 22:23:34.000000000 +0200
+++ mythtv/libs/libmythfreemheg/Visible.h	2008-12-11 23:59:27.000000000 +0100
@@ -1,6 +1,6 @@
 /* Visible.h
 
-   Copyright (C)  David C. J. Matthews 2004  dm at prolingua.co.uk
+   Copyright (C)  David C. J. Matthews 2004, 2008  dm at prolingua.co.uk
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
@@ -124,13 +124,41 @@
     virtual MHIngredient *Clone(MHEngine *) { return new MHRectangle(*this); } // Create a clone of this ingredient.
 };
 
+// The Interactible class is described as a "mix-in" class.  It is used
+// in various classes which complicates inheritance.
 class MHInteractible
 {
 public:
-    MHInteractible();
+    MHInteractible(MHVisible *parent);
     virtual ~MHInteractible();
-    virtual void Initialise(MHParseNode *p, MHEngine *engine);
-    virtual void PrintMe(FILE *fd, int nTabs) const;
+    void Initialise(MHParseNode *p, MHEngine *engine);
+    void PrintMe(FILE *fd, int nTabs) const;
+
+    virtual void Interaction(MHEngine *engine);
+
+    // This is called whenever a key is pressed while this
+    // interactible is set to interactive.
+    virtual void KeyEvent(MHEngine */*engine*/, int /*nCode*/) {}
+    virtual void InteractionCompleted(MHEngine */*engine*/) {}
+
+    void InteractSetInteractionStatus(bool newStatus, MHEngine *engine);
+    bool InteractGetInteractionStatus(void) { return m_fInteractionStatus; }
+    void InteractSetHighlightStatus(bool newStatus, MHEngine *engine);
+    bool InteractGetHighlightStatus(void) { return m_fHighlightStatus; }
+    // InteractDeactivation should be applied in every Deactivation action
+    // of derived classes.
+    void InteractDeactivation(void) { m_fInteractionStatus = false; }
+
+protected:
+    // Exchanged attributes
+    bool     m_fEngineResp;
+    MHColour m_highlightRefColour;
+    // Internal attributes
+    bool     m_fHighlightStatus;
+    bool     m_fInteractionStatus;
+
+private:
+    MHVisible *m_parent;
 };
 
 class MHSlider : public MHVisible, public MHInteractible
@@ -141,7 +169,54 @@
     virtual const char *ClassName() { return "Slider"; }
     virtual void Initialise(MHParseNode *p, MHEngine *engine);
     virtual void PrintMe(FILE *fd, int nTabs) const;
-    virtual void Display(MHEngine *) {} // Not (yet?) supported
+    virtual void Display(MHEngine *);
+    virtual void Preparation(MHEngine *engine);
+
+    virtual void Interaction(MHEngine *engine);
+    virtual void InteractionCompleted(MHEngine *engine);
+    virtual void KeyEvent(MHEngine *engine, int nCode);
+
+    // Implement the actions in the main inheritance line.
+    virtual void SetInteractionStatus(bool newStatus, MHEngine *engine)
+    { InteractSetInteractionStatus(newStatus, engine); }
+    virtual bool GetInteractionStatus(void) { return InteractGetInteractionStatus(); }
+    virtual void SetHighlightStatus(bool newStatus, MHEngine *engine)
+    { InteractSetHighlightStatus(newStatus, engine); }
+    virtual bool GetHighlightStatus(void) { return InteractGetHighlightStatus(); }
+    virtual void Deactivation(MHEngine *engine) { InteractDeactivation(); }
+
+    // Actions
+    virtual void Step(int nbSteps, MHEngine *engine);
+    virtual void SetSliderValue(int newValue, MHEngine *engine);
+    virtual int GetSliderValue(void) { return slider_value; }
+    virtual void SetPortion(int newPortion, MHEngine *engine);
+    virtual int GetPortion(void) { return portion; }
+    // Additional action defined in UK MHEG.
+    virtual void SetSliderParameters(int newMin, int newMax, int newStep, MHEngine *engine);
+
+    // Enumerated type lookup functions for the text parser.
+    static int GetOrientation(const char *str);
+    static int GetStyle(const char *str);
+protected:
+    void Increment(MHEngine *engine);
+    void Decrement(MHEngine *engine);
+
+    // Exchanged attributes
+    // Orientation and direction of increasing value.
+    enum SliderOrientation { SliderLeft = 1, SliderRight, SliderUp, SliderDown }
+        m_orientation;
+    int initial_value, initial_portion;
+    int orig_max_value, orig_min_value, orig_step_size;
+    // Style of slider.  Normal represents a mark on a scale,
+    // Thermometer a range from the start up to the mark and Proportional
+    // a range from the slider to the portion.
+    enum SliderStyle { SliderNormal = 1, SliderThermo, SliderProp }
+        m_style;
+    MHColour m_sliderRefColour;
+    // Internal attributes
+    // In UK MHEG min_value, max_value and step_size can be changed.
+    int max_value, min_value, step_size;
+    int slider_value, portion;
 };
 
 class MHEntryField : public MHVisible, public MHInteractible
@@ -153,6 +228,15 @@
     virtual void Initialise(MHParseNode *p, MHEngine *engine);
     virtual void PrintMe(FILE *fd, int nTabs) const;
     virtual void Display(MHEngine *) {} // Not (yet?) supported
+
+    // Implement the actions in the main inheritance line.
+    virtual void SetInteractionStatus(bool newStatus, MHEngine *engine)
+    { InteractSetInteractionStatus(newStatus, engine); }
+    virtual bool GetInteractionStatus(void) { return InteractGetInteractionStatus(); }
+    virtual void SetHighlightStatus(bool newStatus, MHEngine *engine)
+    { InteractSetHighlightStatus(newStatus, engine); }
+    virtual bool GetHighlightStatus(void) { return InteractGetHighlightStatus(); }
+    virtual void Deactivation(MHEngine *engine) { InteractDeactivation(); }
 };
 
 // Button - not needed for UK MHEG.
@@ -311,4 +395,81 @@
     virtual void CallAction(MHEngine *engine, MHRoot *pTarget, int nArg) { pTarget->SetLineStyle(nArg, engine); };
 };
 
+class MHSetInteractionStatus: public MHActionBool
+{
+public:
+    MHSetInteractionStatus(): MHActionBool("SetInteractionStatus") {}
+    virtual void CallAction(MHEngine *engine, MHRoot *pTarget, bool newStatus)
+    { Target(engine)->SetInteractionStatus(newStatus, engine); }
+};
+
+class MHGetInteractionStatus: public MHActionObjectRef
+{
+public:
+    MHGetInteractionStatus(): MHActionObjectRef(":GetInteractionStatus")  {}
+    virtual void CallAction(MHEngine *, MHRoot *pTarget, MHRoot *pResult)
+        { pResult->SetVariableValue(pTarget->GetInteractionStatus());}
+};
+
+class MHSetHighlightStatus: public MHActionBool
+{
+public:
+    MHSetHighlightStatus(): MHActionBool("SetHighlightStatus") {}
+    virtual void CallAction(MHEngine *engine, MHRoot *pTarget, bool newStatus)
+    { Target(engine)->SetHighlightStatus(newStatus, engine); }
+};
+
+class MHGetHighlightStatus: public MHActionObjectRef
+{
+public:
+    MHGetHighlightStatus(): MHActionObjectRef(":GetHighlightStatus")  {}
+    virtual void CallAction(MHEngine *, MHRoot *pTarget, MHRoot *pResult)
+        { pResult->SetVariableValue(pTarget->GetHighlightStatus());}
+};
+
+class MHStep: public MHActionInt
+{
+public:
+    MHStep(): MHActionInt(":Step") {}
+    virtual void CallAction(MHEngine *engine, MHRoot *pTarget, int nArg) { pTarget->Step(nArg, engine); };
+};
+
+class MHSetSliderValue: public MHActionInt
+{
+public:
+    MHSetSliderValue(): MHActionInt(":SetSliderValue") {}
+    virtual void CallAction(MHEngine *engine, MHRoot *pTarget, int nArg) { pTarget->SetSliderValue(nArg, engine); };
+};
+
+class MHGetSliderValue: public MHActionObjectRef
+{
+public:
+    MHGetSliderValue(): MHActionObjectRef(":GetSliderValue")  {}
+    virtual void CallAction(MHEngine *, MHRoot *pTarget, MHRoot *pResult)
+        { pResult->SetVariableValue(pTarget->GetSliderValue());}
+};
+
+class MHSetPortion: public MHActionInt
+{
+public:
+    MHSetPortion(): MHActionInt(":SetPortion") {}
+    virtual void CallAction(MHEngine *engine, MHRoot *pTarget, int nArg) { pTarget->SetPortion(nArg, engine); };
+};
+
+class MHGetPortion: public MHActionObjectRef
+{
+public:
+    MHGetPortion(): MHActionObjectRef(":GetPortion")  {}
+    virtual void CallAction(MHEngine *, MHRoot *pTarget, MHRoot *pResult)
+        { pResult->SetVariableValue(pTarget->GetPortion());}
+};
+
+class MHSetSliderParameters: public MHActionInt3
+{
+public:
+    MHSetSliderParameters(): MHActionInt3(":SetSliderParameters") {}
+    virtual void CallAction(MHEngine *engine, MHRoot *pTarget, int newMin, int newMax, int newStep)
+        { pTarget->SetSliderParameters(newMin, newMax, newStep, engine); };
+};
+
 #endif
diff -uNr mythtv-0.21/libs/libmythfreesurround/libmythfreesurround.pro mythtv/libs/libmythfreesurround/libmythfreesurround.pro
--- mythtv-0.21/libs/libmythfreesurround/libmythfreesurround.pro	2008-02-14 00:47:17.000000000 +0100
+++ mythtv/libs/libmythfreesurround/libmythfreesurround.pro	2008-06-04 06:05:51.000000000 +0200
@@ -28,3 +28,5 @@
     LIBS += -L../libavcodec -lavcodec
     INCLUDEPATH += ../libavutil
 }
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythlivemedia/groupsock/GroupsockHelper.cpp mythtv/libs/libmythlivemedia/groupsock/GroupsockHelper.cpp
--- mythtv-0.21/libs/libmythlivemedia/groupsock/GroupsockHelper.cpp	2006-06-21 23:20:20.000000000 +0200
+++ mythtv/libs/libmythlivemedia/groupsock/GroupsockHelper.cpp	2008-11-05 01:58:33.000000000 +0100
@@ -34,6 +34,7 @@
 // By default, use INADDR_ANY for the sending and receiving interfaces:
 netAddressBits SendingInterfaceAddr = INADDR_ANY;
 netAddressBits ReceivingInterfaceAddr = INADDR_ANY;
+netAddressBits ReceivingSocketAddr = INADDR_ANY;
 
 static void socketErr(UsageEnvironment& env, char* errorMsg) {
 	env.setResultErrMsg(errorMsg);
@@ -93,7 +94,7 @@
 #else
   if (port.num() != 0 || ReceivingInterfaceAddr != INADDR_ANY) {
 #endif
-    MAKE_SOCKADDR_IN(name, ReceivingInterfaceAddr, port.num());
+    MAKE_SOCKADDR_IN(name, ReceivingSocketAddr, port.num());
     if (bind(newSocket, (struct sockaddr*)&name, sizeof name) != 0) {
       char tmpBuffer[100];
       sprintf(tmpBuffer, "bind() error (port number: %d): ",
@@ -560,6 +561,8 @@
       testAddr.s_addr = our_inet_addr("228.67.43.91"); // arbitrary
       Port testPort(15947); // ditto
       
+      ReceivingSocketAddr = INADDR_ANY;
+
       sock = setupDatagramSocket(env, testPort);
       if (sock < 0) break;
       
diff -uNr mythtv-0.21/libs/libmythlivemedia/groupsock/include/GroupsockHelper.hh mythtv/libs/libmythlivemedia/groupsock/include/GroupsockHelper.hh
--- mythtv-0.21/libs/libmythlivemedia/groupsock/include/GroupsockHelper.hh	2006-06-21 23:20:20.000000000 +0200
+++ mythtv/libs/libmythlivemedia/groupsock/include/GroupsockHelper.hh	2008-11-05 01:58:33.000000000 +0100
@@ -79,6 +79,7 @@
 // are INADDR_ANY (i.e., 0), specifying the default interface.)
 extern netAddressBits SendingInterfaceAddr;
 extern netAddressBits ReceivingInterfaceAddr;
+extern netAddressBits ReceivingSocketAddr;
 
 // Allocates a randomly-chosen IPv4 SSM (multicast) address:
 netAddressBits chooseRandomIPv4SSMAddress(UsageEnvironment& env);
diff -uNr mythtv-0.21/libs/libmythlivemedia/libmythlivemedia.pro mythtv/libs/libmythlivemedia/libmythlivemedia.pro
--- mythtv-0.21/libs/libmythlivemedia/libmythlivemedia.pro	2007-09-26 22:02:25.000000000 +0200
+++ mythtv/libs/libmythlivemedia/libmythlivemedia.pro	2008-06-04 06:05:51.000000000 +0200
@@ -304,3 +304,5 @@
     SOURCES += liveMedia/WAVAudioFileServerMediaSubsession.cpp
     SOURCES += liveMedia/WAVAudioFileSource.cpp
 }
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythlivemedia/liveMedia/RTSPClient.cpp mythtv/libs/libmythlivemedia/liveMedia/RTSPClient.cpp
--- mythtv-0.21/libs/libmythlivemedia/liveMedia/RTSPClient.cpp	2008-02-12 22:33:20.000000000 +0100
+++ mythtv/libs/libmythlivemedia/liveMedia/RTSPClient.cpp	2008-03-29 20:01:18.000000000 +0100
@@ -2124,11 +2124,11 @@
   Boolean haveSeenNonCRLF = False;
   int bytesRead = 1; // because we've already read the first byte
   while (bytesRead < (int)responseBufferSize) {
-    unsigned bytesReadNow
+    int bytesReadNow
       = readSocket(envir(), fInputSocketNum,
 		   (unsigned char*)(responseBuffer+bytesRead),
 		   1, fromAddress);
-    if (bytesReadNow == 0) {
+    if (bytesReadNow <= 0) {
       envir().setResultMsg("RTSP response was truncated");
       break;
     }
